package ch.hslu;

import javax.xml.ws.Endpoint;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import ch.hslu.appe.inventory.webservice.InventoryService;
import ch.hslu.appe.inventory.webservice.InventoryServiceImpl;
import ch.hslu.appe.order.webservice.OrderService;
import ch.hslu.appe.order.webservice.OrderServiceImpl;
import ch.hslu.appe.usermanagement.webservice.AccessService;
import ch.hslu.appe.usermanagement.webservice.AccessServiceImpl;
import ch.hslu.appe.usermanagement.webservice.UserManagementService;
import ch.hslu.appe.usermanagement.webservice.UserManagementServiceImpl;

/**
 * WebServices Main-Class.
 */
public class Program {

    static final Logger LOGGER = LogManager.getLogger("Service");

    /**
     * Main Method.
     * @param args cmd ards
     */
    public static void main(final String[] args) {

        startWebservices();
    }

    /**
     * Starts all available webservices.
     */
    private static void startWebservices() {

        final UserManagementService userManagementService = new UserManagementServiceImpl();
        final AccessService accessService = new AccessServiceImpl();
        final OrderService orderService = new OrderServiceImpl();
        final InventoryService inventoryService = new InventoryServiceImpl();

        Endpoint.publish("http://localhost:8080/UserManagement", userManagementService);
        Endpoint.publish("http://localhost:8080/Access", accessService);
        Endpoint.publish("http://localhost:8080/Order", orderService);
        Endpoint.publish("http://localhost:8080/Inventory", inventoryService);

        LOGGER.info("Accounting Webservices gestartet");
    }
}
