package ch.hslu.appe.accounting.webservice.Dto;

import java.util.Date;

import ch.hslu.appe.order.model.Bill;

/**
 * Bill DTO.
 */
public final class BillDto {
    /**
     * Constructor to generate a BillDTO from a Bill.
     * @param bill bill to convert
     * @return billDTO
     */
    public static BillDto fromBill(final Bill bill) {
        final BillDto billDto = new BillDto();

        return billDto;
    }

    private int addressId;
    private float dunningCosts;
    private Date invoiceDate;
    private int orderNumber;
    private Date paymentDueDate;
    private int state;
    private int type;

    /**
     * gets the address.
     * @return address
     */
    public int getAddressId() {
        return addressId;
    }

    /**
     * gets the dunning costs (Mahnspesen).
     * @return the dunningCosts
     */
    public float getDunningCosts() {
        return dunningCosts;
    }

    /**
     * gets the invoice date.
     * @return the invoiceDate
     */
    public Date getInvoiceDate() {
        return invoiceDate;
    }

    /**
     * gets the Order Number.
     * @return order number
     */
    public int getOrderNumber() {
        return orderNumber;
    }

    /**
     * gets the payment due date.
     * @return the paymentDueDate
     */
    public Date getPaymentDueDate() {
        return paymentDueDate;
    }

    /**
     * gets the state (open, paid, etc) of the bill.
     * @return the bill-state
     */
    public int getState() {
        return state;
    }

    /**
     * gets the typ (bill, reminder, etc.) of the bill.
     * @return the bill-typ
     */
    public int getType() {
        return type;
    }

    /**
     * sets the bill address.
     * @param addressId to be set
     */
    public void setAddressId(final int addressId) {
        this.addressId = addressId;
    }

    /**
     * sets the dunning costs (Mahnspesen).
     * @param dunningCosts the dunningCoasts to set
     */
    public void setDunningCosts(final float dunningCosts) {
        this.dunningCosts = dunningCosts;
    }

    /**
     * sets the invoice date.
     * @param invoiceDate the invoiceDate to set
     */
    public void setInvoiceDate(final Date invoiceDate) {
        this.invoiceDate = invoiceDate;
    }

    /**
     * sets the order number.
     * @param orderNumber orderNumber
     */
    public void setOrderNumber(final int orderNumber) {
        this.orderNumber = orderNumber;
    }

    /**
     * sets the payment due date.
     * @param paymentDueDate the paymentDueDate to set
     */
    public void setPaymentDueDate(final Date paymentDueDate) {
        this.paymentDueDate = paymentDueDate;
    }

    /**
     * sets the state (open, paid, etc) of the bill.
     * @param state the state to set
     */
    public void setState(final int state) {
        this.state = state;
    }

    /**
     * sets the typ (bill, reminder, etc.) of the bill.
     * @param type the typ to set
     */
    public void setType(final int type) {
        this.type = type;
    }

    /**
     * Convert the DTO to a Bill.
     * @return bill
     */
    public Bill toBill() {
        // TODO Convert a BillDTO to a Bill
        return null;
    }
}
