package ch.hslu.appe.helper;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

/**
 * Hash Helper.
 */
public final class HashHelper {

    /**
     * Generates a sha1 hash.
     * @param payload The payload
     * @return Returns the hashed payload
     */
    public static String sha1(final String payload) {
        return sha1(payload, "");
    }

    /**
     * Generates a sha1 hash.
     * @param payload The payload
     * @param salt The optional salt
     * @return Returns the hashed payload
     */
    public static String sha1(final String payload, final String salt) {

        MessageDigest digest;
        try {
            digest = MessageDigest.getInstance("SHA1");
        } catch (NoSuchAlgorithmException e) {

            return "";
        }

        final byte[] result = digest.digest((salt + payload).getBytes());

        final StringBuffer stringBuffer = new StringBuffer();
        for (int index = 0; index < result.length; index++) {
            stringBuffer.append(Integer.toString((result[index] & 0xff) + 0x100, 16).substring(1));
        }

        return stringBuffer.toString();
    }
}
