package ch.hslu.appe.usermanagement.webservice.dto;

import javax.xml.bind.annotation.XmlElement;

import ch.hslu.appe.usermanagement.logic.session.Session;

/**
 * Session DTO.
 */
public final class SessionDto {

    /**
     * Constructor to create the DTO from a Session.
     * @param session Session-Object
     * @return SessionDTO
     */
    public static SessionDto fromSession(final Session session) {

        if (session == null) {
            return null;
        }

        final SessionDto sessionDto = new SessionDto(session.getKey());

        return sessionDto;
    }

    private final String key;

    /**
     * Constructor, sets the Key.
     * @param key to be set
     */
    public SessionDto(final String key) {
        this.key = key;
    }

    /**
     * Returns the Key.
     * @return Session Key
     */
    @XmlElement(required = true)
    public String getKey() {
        return key;
    }
}
